module Knuckleheads

  require 'active_support/core_ext'

  require_relative '../knuckleheads/playable'

  class Player

    include Playable
  
    attr_accessor :name
    attr_reader :health

    def initialize(name, health=100)
      @name = name.titleize
      @health = health
      @treasures = Hash.new(0)
    end

    def to_s
      "I'm #{@name} with a health of #{@health} and a score of #{score}."
    end

    def score
      @health + points
    end

    def <=>(other)
      other.score <=> score
    end

    def print_name_and_score
      puts "#{@name} (#{score})"
    end

    def found_treasure(treasure)
      @treasures[treasure.name] += treasure.points
      puts "#{@name} found a #{treasure.name} worth #{treasure.points} points."
    end

    def points
      @treasures.values.reduce(0,:+)
    end

    def each_treasure
      @treasures.each do |name, points|
        yield Treasure.new(name, points)
      end
    end

  end

end
